diff --git a/gnu/local.mk b/gnu/local.mk
index 37166bb2fc..e1d382c543 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1823,6 +1823,8 @@ dist_patch_DATA =						\
   %D%/packages/patches/xf86-video-voodoo-pcitag.patch		\
   %D%/packages/patches/xfce4-panel-plugins.patch		\
   %D%/packages/patches/xfce4-settings-defaults.patch		\
+  %D%/packages/patches/xgboost-python-use-system-libxgboost.patch \
+  %D%/packages/patches/xgboost-use-system-dmlc-core.patch       \
   %D%/packages/patches/xmonad-dynamic-linking.patch		\
   %D%/packages/patches/xplanet-1.3.1-cxx11-eof.patch		\
   %D%/packages/patches/xplanet-1.3.1-libdisplay_DisplayOutput.cpp.patch	\
diff --git a/gnu/packages/machine-learning.scm b/gnu/packages/machine-learning.scm
index 9d6c5505f7..d81370797f 100644
--- a/gnu/packages/machine-learning.scm
+++ b/gnu/packages/machine-learning.scm
@@ -1959,6 +1959,39 @@ offers the bricks to build efficient and scalable distributed machine
 learning libraries.")
       (license license:asl2.0))))
 
+(define-public xgboost
+  (package
+    (name "xgboost")
+    (version "1.4.1")
+    (source
+     (origin
+       (method git-fetch)
+       (uri (git-reference
+             (url "https://github.com/dmlc/xgboost")
+             (commit (string-append "v" version))))
+       (file-name (git-file-name name version))
+       (patches (search-patches "xgboost-python-use-system-libxgboost.patch"
+                                "xgboost-use-system-dmlc-core.patch"))
+       (sha256
+        (base32 "0ixacmpcj844c09xigi1vd4rrckld84k32iarvhnvvm6yjih756y"))))
+    (build-system cmake-build-system)
+    (arguments
+     `(#:configure-flags (list "-DGOOGLE_TEST=ON")))
+    (native-inputs
+     `(("googletest" ,googletest)
+       ("python" ,python-wrapper)))
+    (inputs
+     `(("dmlc-core" ,dmlc-core)))
+    (home-page "https://xgboost.ai/")
+    (synopsis "Gradient boosting (GBDT, GBRT or GBM) library in C++")
+    (description
+     "XGBoost is an optimized distributed gradient boosting library designed
+to be highly efficient, flexible and portable.  It implements machine learning
+algorithms under the Gradient Boosting framework.  XGBoost provides a parallel
+tree boosting (also known as GBDT, GBM) that solve many data science problems
+in a fast and accurate way.")
+    (license license:asl2.0)))
+
 (define-public python-iml
   (package
     (name "python-iml")
diff --git a/gnu/packages/patches/xgboost-python-use-system-libxgboost.patch b/gnu/packages/patches/xgboost-python-use-system-libxgboost.patch
new file mode 100644
index 0000000000..992e6bb3fd
--- /dev/null
+++ b/gnu/packages/patches/xgboost-python-use-system-libxgboost.patch
@@ -0,0 +1,69 @@
+From 768192b9c6700f0ae6b750c56b114d7022692a0b Mon Sep 17 00:00:00 2001
+From: Vinicius Monego <monego@posteo.net>
+Date: Tue, 11 May 2021 19:30:55 -0300
+Subject: [PATCH] Python wrapper: use system libxgboost.
+
+---
+This patch was extended from the following Debian patch: https://sources.debian.org/src/xgboost/1.2.1-1/debian/patches/setup.py.patch/
+
+ python-package/setup.py            | 4 ++--
+ python-package/xgboost/__init__.py | 5 ++---
+ python-package/xgboost/libpath.py  | 5 +++++
+ 3 files changed, 9 insertions(+), 5 deletions(-)
+
+diff --git a/python-package/setup.py b/python-package/setup.py
+index a2feb766..b8b78429 100644
+--- a/python-package/setup.py
++++ b/python-package/setup.py
+@@ -312,11 +312,11 @@ if __name__ == '__main__':
+               'numpy',
+               'scipy',
+           ],
+-          ext_modules=[CMakeExtension('libxgboost')],
++          # ext_modules=[CMakeExtension('libxgboost')],
+           cmdclass={
+               'build_ext': BuildExt,
+               'sdist': Sdist,
+-              'install_lib': InstallLib,
++              # 'install_lib': InstallLib,
+               'install': Install
+           },
+           extras_require={
+diff --git a/python-package/xgboost/__init__.py b/python-package/xgboost/__init__.py
+index e0ff434d..658e84e6 100644
+--- a/python-package/xgboost/__init__.py
++++ b/python-package/xgboost/__init__.py
+@@ -21,9 +21,8 @@ try:
+ except ImportError:
+     pass
+ 
+-VERSION_FILE = os.path.join(os.path.dirname(__file__), 'VERSION')
+-with open(VERSION_FILE) as f:
+-    __version__ = f.read().strip()
++# This variable will be set during substitution.
++__version__ = ''
+ 
+ __all__ = ['DMatrix', 'DeviceQuantileDMatrix', 'Booster',
+            'train', 'cv',
+diff --git a/python-package/xgboost/libpath.py b/python-package/xgboost/libpath.py
+index f7a7d9cd..88d9d986 100644
+--- a/python-package/xgboost/libpath.py
++++ b/python-package/xgboost/libpath.py
+@@ -19,9 +19,14 @@ def find_lib_path() -> List[str]:
+     lib_path
+        List of all found library path to xgboost
+     """
++
++    # This variable will be set during substitution.
++    XGBOOST_PATH = ''
++
+     curr_path = os.path.dirname(os.path.abspath(os.path.expanduser(__file__)))
+     dll_path = [
+         # normal, after installation `lib` is copied into Python package tree.
++        os.path.join(XGBOOST_PATH, 'lib'),
+         os.path.join(curr_path, 'lib'),
+         # editable installation, no copying is performed.
+         os.path.join(curr_path, os.path.pardir, os.path.pardir, 'lib'),
+-- 
+2.31.1
+
diff --git a/gnu/packages/patches/xgboost-use-system-dmlc-core.patch b/gnu/packages/patches/xgboost-use-system-dmlc-core.patch
new file mode 100644
index 0000000000..6209ae1f10
--- /dev/null
+++ b/gnu/packages/patches/xgboost-use-system-dmlc-core.patch
@@ -0,0 +1,35 @@
+From 34167cc105e47589b86b6f62da76e0ab744002dd Mon Sep 17 00:00:00 2001
+From: Vinicius Monego <monego@posteo.net>
+Date: Tue, 11 May 2021 19:35:30 -0300
+Subject: [PATCH] Use dmlc-core from Guix.
+
+---
+This patch is a subset from the following Debian patch: https://sources.debian.org/src/xgboost/1.2.1-1/debian/patches/cmake.patch/
+
+Rabit is now developed as part of xgboost, so we don't build it separately.
+
+ CMakeLists.txt | 8 +++-----
+ 1 file changed, 3 insertions(+), 5 deletions(-)
+
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 6cc19fbd..3b42bc17 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -150,11 +150,9 @@ endif (USE_OPENMP)
+ 
+ # dmlc-core
+ msvc_use_static_runtime()
+-add_subdirectory(${xgboost_SOURCE_DIR}/dmlc-core)
+-set_target_properties(dmlc PROPERTIES
+-  CXX_STANDARD 14
+-  CXX_STANDARD_REQUIRED ON
+-  POSITION_INDEPENDENT_CODE ON)
++add_library(dmlc SHARED IMPORTED)
++find_library(DMLC_LIBRARY dmlc)
++set_property(TARGET dmlc PROPERTY IMPORTED_LOCATION "${DMLC_LIBRARY}")
+ if (MSVC)
+   target_compile_options(dmlc PRIVATE
+                          -D_CRT_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_DEPRECATE)
+-- 
+2.31.1
+